/***************************************************************************
 *             __________               __   ___.
 *   Open      \______   \ ____   ____ |  | _\_ |__   _______  ___
 *   Source     |       _//  _ \_/ ___\|  |/ /| __ \ /  _ \  \/  /
 *   Jukebox    |    |   (  <_> )  \___|    < | \_\ (  <_> > <  <
 *   Firmware   |____|_  /\____/ \___  >__|_ \|___  /\____/__/\_ \
 *                     \/            \/     \/    \/            \/
 *
 * Copyright (C) 2005 by Dave Chapman
 * Copyright (C) 2009 by Karl Kurbjun
 *
 * Rockbox driver for 16-bit colour LCDs
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This software is distributed on an "AS IS" basis, WITHOUT WARRANTY OF ANY
 * KIND, either express or implied.
 *
 ****************************************************************************/

#include "config.h"

#include "cpu.h"
#include "lcd.h"
#ifdef HAVE_REMOTE_LCD
#include "lcd-remote.h"
#endif
#include "kernel.h"
#include "thread.h"
#include <stdlib.h>
#include "string-extra.h" /* mem*() */
#include "file.h"
#include "debug.h"
#include "system.h"
#include "font.h"
#include "rbunicode.h"
#include "bidi.h"
#include "scroll_engine.h"

// #define LOGF_ENABLE
#include "logf.h"

#ifndef LCDFN /* Not compiling for remote - define macros for main LCD. */
#define LCDFN(fn) lcd_ ## fn
#define FBFN(fn)  fb_ ## fn
#define FBSIZE FRAMEBUFFER_SIZE
#define LCDM(ma) LCD_ ## ma
#define LCDFB(x,y) FBADDR(x, y)
#define LCDNAME "lcd_"
#define MAIN_LCD
#endif

#ifndef CURRENT_VP
#define CURRENT_VP LCDFN(current_viewport)
#endif

#ifdef MAIN_LCD
#define THIS_STRIDE STRIDE_MAIN
#else
#define THIS_STRIDE STRIDE_REMOTE
#endif

#define ROW_INC CURRENT_VP->buffer->stride
#define COL_INC 1

extern LCDFN(fastpixelfunc_type)* const LCDFN(fastpixelfuncs_backdrop)[];
extern LCDFN(fastpixelfunc_type)* const LCDFN(fastpixelfuncs_bgcolor)[];

#ifndef DISABLE_ALPHA_BITMAP
static void ICODE_ATTR LCDFN(alpha_bitmap_part_mix)(const FBFN(data)* image,
                                      const unsigned char *src, int src_x,
                                      int src_y, int x, int y,
                                      int width, int height,
                                      int stride_image, int stride_src);
#endif /* !DISABLE_ALPHA_BITMAP */
#include "lcd-color-common.c"
#include "lcd-bitmap-common.c"
#include "lcd-16bit-common.c"

/*** drawing functions ***/

/* Draw a horizontal line (optimised) */
void LCDFN(hline)(int x1, int x2, int y)
{
    struct viewport *vp = CURRENT_VP;
    int width;
    unsigned bits = 0;
    enum fill_opt fillopt = OPT_NONE;
    FBFN(data) *dst, *dst_end;

    if (!clip_viewport_hline(vp, &x1, &x2, &y))
        return;

    width = x2 - x1 + 1;

    /* drawmode and optimisation */
    if (vp->drawmode & DRMODE_INVERSEVID)
    {
        if (vp->drawmode & DRMODE_BG)
        {
            if (!LCDFN(backdrop))
            {
                fillopt = OPT_SET;
                bits = vp->bg_pattern;
            }
            else
                fillopt = OPT_COPY;
        }
    }
    else
    {
        if (vp->drawmode & DRMODE_FG)
        {
            fillopt = OPT_SET;
            bits = vp->fg_pattern;
        }
    }
    if (fillopt == OPT_NONE && vp->drawmode != DRMODE_COMPLEMENT)
        return;

    dst = LCDFB(x1, y);

    switch (fillopt)
    {
      case OPT_SET:
        memset16(dst, bits, width);
        break;

      case OPT_COPY:
        memcpy(dst, PTR_ADD(dst, LCDFN(backdrop_offset)),
               width * sizeof(FBFN(data)));
        break;

      case OPT_NONE:  /* DRMODE_COMPLEMENT */
        dst_end = dst + width;
        do
            *dst = ~(*dst);
        while (++dst < dst_end);
        break;
    }
}

/* Draw a vertical line (optimised) */
void LCDFN(vline)(int x, int y1, int y2)
{
    struct viewport *vp = CURRENT_VP;
    FBFN(data) *dst, *dst_end;
    int stride_dst;
    LCDFN(fastpixelfunc_type) *pfunc = LCDFN(fastpixelfuncs)[vp->drawmode];

    if (!clip_viewport_vline(vp, &x, &y1, &y2))
        return;

    dst = LCDFB(x, y1);
    stride_dst = vp->buffer->stride;
    dst_end = dst + (y2 - y1) * stride_dst;

    do
    {
        pfunc(dst);
        dst += stride_dst;
    }
    while (dst <= dst_end);
}

/* Draw a partial native bitmap */
void ICODE_ATTR LCDFN(bitmap_part)(const FBFN(data) *src, int src_x, int src_y,
                                int stride, int x, int y, int width,
                                int height)
{
    struct viewport *vp = CURRENT_VP;
    FBFN(data) *dst;
    int stride_dst;

    if (!clip_viewport_rect(vp, &x, &y, &width, &height, &src_x, &src_y))
        return;

    src += stride * src_y + src_x; /* move starting point */
    dst = LCDFB(x, y);
    stride_dst = vp->buffer->stride;

    do
    {
        memcpy(dst, src, width * sizeof(FBFN(data)));
        src += stride;
        dst += stride_dst;
    }
    while (--height > 0);
}

/* Draw a partial native bitmap with transparency and foreground colors */
void ICODE_ATTR LCDFN(bitmap_transparent_part)(const FBFN(data) *src, int src_x,
                                            int src_y, int stride, int x,
                                            int y, int width, int height)
{
    struct viewport *vp = CURRENT_VP;
    FBFN(data) *dst;
    unsigned fg = vp->fg_pattern;
    int stride_dst = vp->buffer->stride;

    if (!clip_viewport_rect(vp, &x, &y, &width, &height, &src_x, &src_y))
        return;

    src += stride * src_y + src_x; /* move starting point */
    dst = LCDFB(x, y);

#ifdef CPU_ARM
    {
        int w, px;
        asm volatile (
            BEGIN_ARM_ASM_SYNTAX_UNIFIED
        ".rowstart:                              \n"
            "mov     %[w], %[width]              \n" /* Load width for inner loop */
        ".nextpixel:                             \n"
            "ldrh    %[px], [%[s]], #2           \n" /* Load src pixel */
            "add     %[d], %[d], #2              \n" /* Uncoditionally increment dst */
                                                 /* done here for better pipelining */
            "cmp     %[px], %[fgcolor]           \n" /* Compare to foreground color */
            "strheq  %[fgpat], [%[d], #-2]       \n" /* Store foregroud if match */
            "cmpne   %[px], %[transcolor]        \n" /* Compare to transparent color */
            "strhne  %[px], [%[d], #-2]          \n" /* Store dst if not transparent */
            "subs    %[w], %[w], #1              \n" /* Width counter has run down? */
            "bgt     .nextpixel                  \n" /* More in this row? */
            "add     %[s], %[s], %[sstp], lsl #1 \n" /* Skip over to start of next line */
            "add     %[d], %[d], %[dstp], lsl #1 \n"
            "subs    %[h], %[h], #1              \n" /* Height counter has run down? */
            "bgt     .rowstart                   \n" /* More rows? */
            END_ARM_ASM_SYNTAX_UNIFIED
            : [w]"=&r"(w), [h]"+&r"(height), [px]"=&r"(px),
              [s]"+&r"(src), [d]"+&r"(dst)
            : [width]"r"(width),
              [sstp]"r"(stride - width),
              [dstp]"r"(stride_dst - width),
              [transcolor]"r"(TRANSPARENT_COLOR),
              [fgcolor]"r"(REPLACEWITHFG_COLOR),
              [fgpat]"r"(fg)
        );
    }
#else  /* optimized C version */
    do
    {
        const FBFN(data) *src_row = src;
        FBFN(data) *dst_row = dst;
        FBFN(data) *row_end = dst_row + width;
        do
        {
            unsigned data = *src_row++;
            if (data != TRANSPARENT_COLOR)
            {
                if (data == REPLACEWITHFG_COLOR)
                    data = fg;
                *dst_row = data;
            }
        }
        while (++dst_row < row_end);
        src += stride;
        dst += stride_dst;
    }
    while (--height > 0);
#endif
}
